"use strict";
function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
Object.defineProperty(exports, "__esModule", { value: true });
const generated_1 = require("./generated");
const fetch = require("node-fetch");
const DEFAULT_API_URL = "https://api.cloud.ravendb.net";
const http = { fetch };
__export(require("./generated"));
class ApiClient {
    constructor(opts) {
        opts = opts || {};
        const baseUrl = opts.url || DEFAULT_API_URL;
        if (!opts.apiKey) {
            throw new Error("Passing an apiKey is required. In order to obtain one please navigate to 'API Keys' in your RavenDB Cloud user portal.");
        }
        this._account = new generated_1.AccountClient(opts, baseUrl, http);
        this._metadata = new generated_1.MetadataClient(opts, baseUrl, http);
        this._products = new generated_1.ProductsClient(opts, baseUrl, http);
    }
    get account() {
        return this._account;
    }
    ;
    get products() {
        return this._products;
    }
    get metadata() {
        return this._metadata;
    }
}
exports.ApiClient = ApiClient;
